﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Speech.Synthesis;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AAE2023_13
{
    public partial class Form1 : Form
    {
        SpeechSynthesizer engine = new SpeechSynthesizer();
        HttpClient client = new HttpClient();
        public Form1()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            engine.Speak(textBox1.Text);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            richTextBox1.Clear();
            foreach(InstalledVoice voice in engine.GetInstalledVoices())
            {
                richTextBox1.AppendText(voice.VoiceInfo.Name + Environment.NewLine);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            foreach (InstalledVoice voice in engine.GetInstalledVoices())
            {
                comboBox1.Items.Add(voice.VoiceInfo.Name);
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            engine.SelectVoice(comboBox1.Text);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            engine.SpeakAsync(textBox1.Text);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            engine.Volume = trackBar1.Value;
        }

        private async void button4_Click(object sender, EventArgs e)
        {
            String jsonResponse = await client.GetStringAsync("https://official-joke-api.appspot.com/jokes/programming/random");
            //MessageBox.Show(jsonResponse);
            String jsonObject = jsonResponse.Remove(0, 1).Remove(jsonResponse.Length - 2, 1);
            var dictionary = JsonConvert.DeserializeObject<Dictionary<string, string>>(jsonObject);
            engine.SpeakAsync(dictionary["setup"]);
            MessageBox.Show(dictionary["setup"]);
            engine.SpeakAsync(dictionary["punchline"]);
            MessageBox.Show(dictionary["punchline"]);
        }
    }
}
